// OptionsMainSheet.cpp : implementation file
//

#include "stdafx.h"
#include "o3find_wingui.h"
#include "OptionsMainSheet.h"
#include "Options.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionsMainSheet

IMPLEMENT_DYNAMIC(COptionsMainSheet, CPropertySheet)

COptionsMainSheet::COptionsMainSheet(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	InitPages();
}

COptionsMainSheet::COptionsMainSheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	InitPages();
}

COptionsMainSheet::~COptionsMainSheet()
{
}


BEGIN_MESSAGE_MAP(COptionsMainSheet, CPropertySheet)
	//{{AFX_MSG_MAP(COptionsMainSheet)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsMainSheet message handlers

void COptionsMainSheet::InitPages()
{
	//m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	//m_psh.dwFlags |= PSP_USEHICON;
	//m_psh.hIcon = m_hIcon;
	m_psh.dwFlags |= PSH_NOAPPLYNOW;    // Lose the Apply Now button
	//m_psh.dwFlags &= ~PSH_HASHELP;  // Lose the Help button

	AddPage(&m_pageSettings);
	AddPage(&m_pageRemember);
	AddPage(&m_pageClear);
}

void COptionsMainSheet::SetOptions(const CO3FindOptions &options)
{
	m_pageSettings.m_bCheckAlreadyOpen = options.m_bAlreadyOpen;
	m_pageSettings.m_bCheckIgnoreStyles = options.m_bIgnoreStyle;
	m_pageSettings.m_bCheckRememberSettings = options.m_bRememberSettings;
	m_pageSettings.m_nRadioSearchFor = 0;
	if (!options.m_bContent && options.m_bMetaData)
		m_pageSettings.m_nRadioSearchFor = 2;
	else if (options.m_bContent && !options.m_bMetaData)
		m_pageSettings.m_nRadioSearchFor = 1;

	m_pageRemember.m_bCheckRememberDirectory = options.m_bRememberDirectory;
	m_pageRemember.m_bCheckRememberFileType = options.m_bRememberFilesSearched;
	m_pageRemember.m_bCheckRememberMain = options.m_bRememberMainWindowOptions;
	m_pageRemember.m_bCheckRememberSearchString = options.m_bRememberTextSearched;

} // COptionsMainSheet::SetOptions


void COptionsMainSheet::GetOptions(CO3FindOptions& options)
{
	options.m_bAlreadyOpen = m_pageSettings.m_bCheckAlreadyOpen;
	options.m_bIgnoreStyle = m_pageSettings.m_bCheckIgnoreStyles;
	options.m_bRememberSettings = m_pageSettings.m_bCheckRememberSettings;

	switch(m_pageSettings.m_nRadioSearchFor)
	{
		case 0 : 
			options.m_bContent = true; 
			options.m_bMetaData = true;
			break;
		case 1 : 
			options.m_bContent = true; 
			options.m_bMetaData = false;
			break;
		case 2 : 
			options.m_bContent = false; 
			options.m_bMetaData = true;
			break;
		default:
			options.m_bContent = true; 
			options.m_bMetaData = true;
	} // end switch

	options.m_bRememberDirectory = m_pageRemember.m_bCheckRememberDirectory;
	options.m_bRememberFilesSearched = m_pageRemember.m_bCheckRememberFileType;
	options.m_bRememberMainWindowOptions = m_pageRemember.m_bCheckRememberMain;
	options.m_bRememberTextSearched = m_pageRemember.m_bCheckRememberSearchString;
} // COptionsMainSheet::GetOptions

