/*
 *	Title:		o3find
 *	Version:	0.8.2
 *	Created by:	Paolo Copello
 *	Home page:	http://web.tiscali.it/fanelia
 *	
 *	Copyright (C) 2003-2005 Paolo Copello
 *	
 *	******************************************
 *	This file is part of o3find
 *	******************************************
 *	
 *	o3find is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	any later version.
 *	
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *	
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *	
 */


// o3find_winguiDlg.cpp : implementation file
//

#include "stdafx.h"

// suppress "truncated debug info" warnings (VC++ specific)
#ifdef _MSC_VER
#pragma warning (disable: 4786)
#pragma warning (disable: 4788)
#endif // _MSC_VER


#include "o3find_wingui.h"
#include "o3find_winguiDlg.h"

#include "OptionsMainSheet.h"

#include "o3find_mfc_class.h"
#include "../common/fnfilefind.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CO3find_winguiDlg dialog

CO3find_winguiDlg::CO3find_winguiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CO3find_winguiDlg::IDD, pParent),
	m_nInitialComboOptionSelected(-1)//, _bIsWindows98orLater(true)
{
	//{{AFX_DATA_INIT(CO3find_winguiDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CO3find_winguiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CO3find_winguiDlg)
	DDX_Control(pDX, IDC_CHECK_CASE_SENSITIVE, c_checkCaseSensitive);
	DDX_Control(pDX, IDC_COMBO_FILE_NAME, c_comboFileName);
	DDX_Control(pDX, IDC_CHECK_SUBFOLDERS, c_checkSubfolders);
	DDX_Control(pDX, IDC_LIST_FOUND, c_listResults);
	DDX_Control(pDX, IDC_EDIT_SEARCH_STRING, c_editSearchString);
	DDX_Control(pDX, IDC_EDIT_DIRECTORY, c_EditDirectory);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CO3find_winguiDlg, CDialog)
	//{{AFX_MSG_MAP(CO3find_winguiDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_START_FIND, OnButtonStartFind)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE, OnButtonBrowse)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_FOUND, OnDblclkListFound)
	ON_COMMAND(IDC_PRESS_ENTER, OnPressEnter)
	ON_BN_CLICKED(IDC_BUTTON_OPTIONS, OnButtonOptions)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CO3find_winguiDlg message handlers

struct _ooo_file_type
{
	int nPatternCode;
	int nTypeDescriptionCode;
};

static _ooo_file_type gFileTypeList[] = 
{	
	{IDS_PATTERN_OOO, IDS_TYPEDESC_OOO},
	{IDS_PATTERN_WRITER, IDS_TYPEDESC_WRITER},
	{IDS_PATTERN_WRITERGLOBAL, IDS_TYPEDESC_WRITERGLOBAL},
	{IDS_PATTERN_CALC, IDS_TYPEDESC_CALC},
	{IDS_PATTERN_DRAW, IDS_TYPEDESC_DRAW},
	{IDS_PATTERN_IMPRESS, IDS_TYPEDESC_IMPRESS},
	{IDS_PATTERN_MATH, IDS_TYPEDESC_MATH},
	{IDS_PATTERN_ALL, IDS_TYPEDESC_ALL},
	{0,0}
};


BOOL CO3find_winguiDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// carica la tabella dei tasti di scelta rapida
	m_hAccelTable = LoadAccelerators(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_ACCELERATOR)); 

	c_listResults.Initialize();

	for(int i=0; gFileTypeList[i].nPatternCode!=0; i++)
	{
		CString str;
		str.LoadString(gFileTypeList[i].nTypeDescriptionCode);
		int nPos = c_comboFileName.AddString(str);
		c_comboFileName.SetItemData(nPos, i);
		if(IDS_PATTERN_OOO == gFileTypeList[i].nPatternCode)
			m_nInitialComboOptionSelected = nPos;
	}

	// initialize search fields
	InitializeSearchFields();

	// read Windows version
//	OSVERSIONINFO osvi;
//	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
//	GetVersionEx (&osvi);
//	_bIsWindows98orLater = VER_PLATFORM_WIN32_NT || 
//	   (osvi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) &&
//	   ( (osvi.dwMajorVersion > 4) ||
//	   ( (osvi.dwMajorVersion == 4) && (osvi.dwMinorVersion > 0) ) );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CO3find_winguiDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CO3find_winguiDlg::OnDestroy()
{
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CO3find_winguiDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CO3find_winguiDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/** Fill the result list */
void CO3find_winguiDlg::ShowResults(const list<string>& lst)
{
	for(list<string>::const_iterator it= lst.begin();
			it!=lst.end(); ++it)
	{
		c_listResults.AddFile(it->c_str());
	}
}

/** Perform the search */
void CO3find_winguiDlg::OnButtonStartFind() 
{
	CWaitCursor wait;
	c_listResults.DeleteAllItems();

	m_options.m_bSubFolders = IsChecked(c_checkSubfolders);
	m_options.m_bCaseSensitive = IsChecked(c_checkCaseSensitive);

	c_EditDirectory.GetWindowText(m_options.m_strLastDirectory);
	c_editSearchString.GetWindowText(m_options.m_strLastTextSearched);

	// check file name or pattern
	int nComboPos = c_comboFileName.GetCurSel();
	if(nComboPos!=CB_ERR)
	{
		m_options.m_strLastFilesSearched.LoadString(
			gFileTypeList[c_comboFileName.GetItemData(nComboPos)].nPatternCode); 
	}
	else
	{
		c_comboFileName.GetWindowText(m_options.m_strLastFilesSearched);
		int nItemFound = c_comboFileName.FindStringExact(0, m_options.m_strLastFilesSearched);
		if(nItemFound!=CB_ERR)
		{
			m_options.m_strLastFilesSearched.LoadString(
				gFileTypeList[c_comboFileName.GetItemData(nItemFound)].nPatternCode); 
		}
	}

	if(m_options.m_strLastFilesSearched.IsEmpty())
		m_options.m_strLastFilesSearched.LoadString(IDS_PATTERN_OOO);

	string sDir(m_options.m_strLastDirectory);
	string sSearch(m_options.m_strLastTextSearched);
	string sFile(m_options.m_strLastFilesSearched);

	list<string> lst;

	Fanel::FileFinder fileFinder;
	fileFinder.Find(sDir, sFile, lst, (bool)m_options.m_bSubFolders);
	
	if(!m_options.m_strLastTextSearched.IsEmpty())
	{
		bool bShowErrors = false;
		bool bShowNotFound = false;
		bool bBriefMode = true;
		Fanel::OoFinder::SEARCH_IN search_in;
		
		// What parts of an OOo document should I search?
		if (m_options.m_bContent && m_options.m_bMetaData)
		{
			search_in = Fanel::OoFinder::CONTENT_AND_META;
		}
		else if (m_options.m_bContent)
		{
			search_in = Fanel::OoFinder::CONTENT_ONLY;
		}
		else
		{
			search_in = Fanel::OoFinder::META_ONLY;
		}

		// Create the finder object
		Fanel::OoFinderMFC oooFinder(
				(bool)m_options.m_bCaseSensitive, 
				bShowErrors, 
				bShowNotFound, 
				bBriefMode, 
				search_in, 
				(bool)m_options.m_bAlreadyOpen,
				(bool)m_options.m_bIgnoreStyle);
	
		// start the search
		oooFinder.Find(lst, sSearch);

		ShowResults(oooFinder.GetResults());
	}
	else
	{
		ShowResults(lst);
	}
}


/** Display a dialog to browse for folders */
void CO3find_winguiDlg::OnButtonBrowse() 
{
	char buffer[MAX_PATH];

	BROWSEINFO bi;
	memset(&bi, 0, sizeof(BROWSEINFO));
	bi.hwndOwner = m_hWnd;
//	bi.lpszTitle = "***";
	//bi.pszDisplayName = buffer;
	bi.ulFlags = BIF_RETURNONLYFSDIRS;  //BIF_EDITBOX ;
	ITEMIDLIST* pItem = SHBrowseForFolder(&bi);
	if(pItem!=NULL)
	{
		if(SHGetPathFromIDList(pItem, buffer))
		{
			c_EditDirectory.SetWindowText(buffer);
		}
		else
		{
			AfxMessageBox(IDS_INVALID_FOLDER_SELECTED, MB_ICONEXCLAMATION);
		}
		LPMALLOC pMalloc = NULL;
		if(SUCCEEDED(SHGetMalloc(&pMalloc)))
		{
			pMalloc->Free(pItem);
			//pMalloc->Release();
		}
	}
}

/** When the user double-clicks a file name, open the file */
void CO3find_winguiDlg::OnDblclkListFound(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OpenSelectedResultFiles();
	*pResult = 0;
}

/** Use the shell to open the selected files */
void CO3find_winguiDlg::OpenSelectedResultFiles()
{
    SHELLEXECUTEINFO shExecInfo;

    shExecInfo.cbSize = sizeof(SHELLEXECUTEINFO);
    shExecInfo.fMask = NULL;
    shExecInfo.hwnd = NULL;
    shExecInfo.lpVerb = NULL;
//    shExecInfo.lpFile = pszParseName;
    shExecInfo.lpParameters = NULL;
    shExecInfo.lpDirectory = NULL;
    shExecInfo.nShow = SW_SHOW;
    shExecInfo.hInstApp = NULL;

	POSITION pos = c_listResults.GetFirstSelectedItemPosition();
	while(pos)
	{
		CString strName = c_listResults.GetItemText(c_listResults.GetNextSelectedItem(pos), 0);
		shExecInfo.lpFile = strName.GetBuffer(0);
		ShellExecuteEx(&shExecInfo);
		strName.ReleaseBuffer();
	}

}

/** Needed to handle the Accelerator Table */
BOOL CO3find_winguiDlg::PreTranslateMessage(MSG* pMsg) 
{
	if (m_hAccelTable) 
	{
		if (::TranslateAccelerator(m_hWnd, m_hAccelTable, pMsg)) 
		{
			return(TRUE);
		}
	}	
	return CDialog::PreTranslateMessage(pMsg);
}

/** Called when ENTER key is pressed: this by default starts the search,
 but it opens the selected files if the results list has the focus */
void CO3find_winguiDlg::OnPressEnter() 
{
	if(GetActiveWindow() == &c_listResults
		|| GetFocus() == &c_listResults)
	{
		OpenSelectedResultFiles();
	}
	else
	{
		OnButtonStartFind();
	}
}

/** Clear the results list and the search fields */
void CO3find_winguiDlg::InitializeSearchFields() 
{
	// "REMEMBER" options and "MAIN WINDOW" options...

	m_options.LoadFromRegistry();

	if (m_options.m_bRememberDirectory &&
		!m_options.m_strLastDirectory.IsEmpty())
	{
		c_EditDirectory.SetWindowText(m_options.m_strLastDirectory);
	}
	else
	{
		try
		{
			char szDocsBuffer [MAX_PATH];
			if(SHGetSpecialFolderPath(m_hWnd, szDocsBuffer, CSIDL_PERSONAL, FALSE))
			{
				c_EditDirectory.SetWindowText(szDocsBuffer);
			}
		}
		catch(...)
		{
			c_EditDirectory.SetWindowText("");
		}
	}

	if (m_options.m_bRememberFilesSearched && 
		!m_options.m_strLastFilesSearched.IsEmpty())
	{
		c_comboFileName.SetWindowText(m_options.m_strLastFilesSearched);
	}
	else
	{
		if(m_nInitialComboOptionSelected>=0)
			c_comboFileName.SetCurSel(m_nInitialComboOptionSelected);
		else
			c_comboFileName.SetWindowText("");
	}
	
	if (m_options.m_bRememberTextSearched)
	{
		c_editSearchString.SetWindowText(m_options.m_strLastTextSearched);
	}

	if (m_options.m_bRememberMainWindowOptions)
	{
		c_checkSubfolders.SetCheck(m_options.m_bSubFolders ? BST_CHECKED : BST_UNCHECKED);
		c_checkCaseSensitive.SetCheck(m_options.m_bCaseSensitive ? BST_CHECKED : BST_UNCHECKED);
	}
	else
	{
		c_checkSubfolders.SetCheck(BST_CHECKED);
		c_checkCaseSensitive.SetCheck(BST_CHECKED);
	}

/*	if(m_nInitialComboOptionSelected>=0)
		c_comboFileName.SetCurSel(m_nInitialComboOptionSelected);
	else
		c_comboFileName.SetWindowText("");

	c_checkSubfolders.SetCheck(BST_CHECKED);
	c_checkCaseSensitive.SetCheck(BST_CHECKED);

	c_editSearchString.SetWindowText("");
*/

}

void CO3find_winguiDlg::OnButtonOptions() 
{
	COptionsMainSheet optionSheet("o3find Options", this);

	optionSheet.SetOptions(m_options);

	int nResult = optionSheet.DoModal();

	if (nResult == IDOK)
	{
		optionSheet.GetOptions(m_options);
	}
	else if (nResult == IDC_BUTTON_CLEAR_SINGLE)
	{
		EndDialog(IDC_BUTTON_CLEAR_SINGLE);
	}
}


/*void CO3find_winguiDlg::OnClose() 
{
	::MessageBox(NULL, "Called OnClose!", "OOOO", MB_OK);
	
	CDialog::OnClose();
}*/


void CO3find_winguiDlg::SaveOptions()
{
	m_options.SaveToRegistry();
}

