/*
 *	Title:		o3find
 *	Version:	0.8.2
 *	Created by:	Paolo Copello
 *	Home page:	http://web.tiscali.it/fanelia
 *	
 *	Copyright (C) 2003-2005 Paolo Copello
 *	
 *	******************************************
 *	This file is part of o3find
 *	******************************************
 *	
 *	o3find is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	any later version.
 *	
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *	
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *	
 */


// o3find_winguiDlg.h : header file
//

#if !defined(AFX_O3FIND_WINGUIDLG_H__08D85BE6_EB5A_11D7_9434_D4CD5895B03E__INCLUDED_)
#define AFX_O3FIND_WINGUIDLG_H__08D85BE6_EB5A_11D7_9434_D4CD5895B03E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ResultsListCtrl.h"
#include "Options.h"


#include <string>
#include <list>
using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CO3find_winguiDlg dialog

class CO3find_winguiDlg : public CDialog
{
// Construction
public:
	CO3find_winguiDlg(CWnd* pParent = NULL);	// standard constructor

	void SaveOptions();

// Dialog Data
	//{{AFX_DATA(CO3find_winguiDlg)
	enum { IDD = IDD_O3FIND_WINGUI_DIALOG };
	CButton	c_checkCaseSensitive;
	CComboBox	c_comboFileName;
	CButton	c_checkSubfolders;
	ResultsListCtrl	c_listResults;
	CEdit	c_editSearchString;
	CEdit	c_EditDirectory;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CO3find_winguiDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void ShowResults(const list<string>& lst);
	void OpenSelectedResultFiles();
	void InitializeSearchFields();

	inline BOOL IsChecked(CButton& checkBox);

	int m_nInitialComboOptionSelected;
	//bool _bIsWindows98orLater;

	HICON m_hIcon;
	HACCEL  m_hAccelTable; 
	
	CO3FindOptions m_options;

	// Generated message map functions
	//{{AFX_MSG(CO3find_winguiDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonStartFind();
	afx_msg void OnButtonBrowse();
	afx_msg void OnDblclkListFound(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnPressEnter();
	afx_msg void OnButtonOptions();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

// INLINE FUNCTIONS

inline BOOL CO3find_winguiDlg::IsChecked(CButton& checkBox)
{
	return ( BST_CHECKED == checkBox.GetCheck() );
}

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_O3FIND_WINGUIDLG_H__08D85BE6_EB5A_11D7_9434_D4CD5895B03E__INCLUDED_)
